var period = null;
//yien 单据状态
var billState = '0';
//yien 是否组织考核
var isOrg = '0';

shr.defineClass("shr.perfweb.evaluresultSummaryAuditEditEx", shr.perfweb.evaluresultSummaryAuditEdit, {
    that: null,
    billId: null,
    initalizeDOM: function () {
        that = this;
        // this.billId = shr.getUrlRequestParam("billId");
        //yien 补丁11 考核结果审批改造
        this.billId = this.initData.billId;
        shr.perfweb.evaluresultSummaryAuditEditEx.superClass.initalizeDOM.call(this);
    },
    //工作流执行不需要执行submit
    beforeSubmit: function (callback) {

        var entrys = [];
        var RowData = $('#entrysIframe').contents().find('#grid').jqGrid('getRowData');
        for (var i = 0; i < RowData.length; i++) {
            var Row = RowData[i];
            Row["evaResult.sumScore"] = '';
            Row["evaResult.auditSumScore"] = '';
            Row["evaResult.auditReason"] = '';
            Row["evaResult.reviseSumScore"] = '';
            Row["reviseGradeLevelSelect"] = '';
            Row["levelScoreKVInfo"] = '';

            entrys.push(Row);
        }
        var entryData = JSON.stringify(entrys);

        var flag = false;
        that.remoteCall({
            method: "verifyBeforeSubmit",
            async: false,
            param: {
                entryData: entryData,
            },
            success: function (response) {
                let data = {};
                data = $.extend(that.prepareParam(), data);
                data = $.extend({permItemId: shr.getCurrentPagePermItemId()}, data);
                const batchTipsData = that.batchTipsDataHandler(response, data);
                if (batchTipsData.successCount > 0 && batchTipsData.failureCount <= 0) {
                    flag = (true);
                } else {
                    let len = 0;
                    $(that).shrMessageTips({
                        isSuccess: batchTipsData.isSuccess,
                        successCount: batchTipsData.successCount,
                        failureCount: batchTipsData.failureCount,
                        confirmCallback: function () {
                            $(that).shrDetailTips({
                                tableData: batchTipsData.tmp,
                                successCount: batchTipsData.successCount,
                                failureCount: batchTipsData.failureCount,
                                colNamesData: batchTipsData.tableModel,
                                isSortable: that.batchHandlerWhetherSortable(),
                                modalWidth: ''
                            }).shrDetailTips("open");
                            let modal_title = $("#detailTipsCode .modal-title");
                            let modal_titleStr = modal_title.html().replace('批量处理结果', "失败原因");
                            modal_title.html(modal_titleStr);
                        },
                        closeCallback: function () {
                        }
                    }).shrMessageTips("open");
                    let modal_title = $("#tips-title");
                    let modal_titleStr = modal_title.html().replace('批量处理结果', "失败原因");
                    modal_title.html(modal_titleStr);
                    flag = (false);
                }
            }
        });
        return flag;

    },

    /**
     * 如果重写过getBatchTipsRowDatas方法，则需要增加对应的列配置属性
     */
    getBatchTipsTableModel: function () {
        var tableModel = $('#entrysIframe').contents().find('#grid').jqGrid("getGridConfig").colModel;
        return tableModel;
    },
    /**
     * 批量提示裂变是否支持排序，方便子类覆写
     */
    batchHandlerWhetherSortable: function () {
        return true;
    },
    /**
     * 批量反馈，处理请求返回数据
     */
    batchTipsDataHandler: function (data, options) {
        var _self = this;
        var successCount = data.successCount;
        var failureCount = data.failureCount;
        var isSuccess = !data.failureCount ? true : false;
        var result = data.result;

        var ids = data.billId.split(','); //使用变量时注意声明，若在方法内部未声明则为全局变量，此处需要注意！
        var tmp = _self.getBatchTipsRowDatas(ids, options); //获取选中的表格数据
        for (var i = 0, l = result.length; i < l; i++) {
            if (result[i].muitTipsState) {
                result[i].muitTipsState = $.shrI18n.common.title.success;
            } else {

                result[i].muitTipsState = $.shrI18n.common.title.failure;
            }
            for (var j = 0, size = tmp.length; j < size; j++) {
                if (tmp[j][_self.getBillIdFieldName()] == result[i].id) {
                    tmp[j].muitTipsState = result[i].muitTipsState;
                    tmp[j].muitTipsMessage = result[i].muitTipsMessage;
                }
            }
        }

        var batchData = {
            "successCount": successCount,
            "failureCount": failureCount,
            "isSuccess": isSuccess,
            "tmp": tmp,
            "tableModel": _self.getBatchTipsTableModel()
        };

        return batchData;
    },
    /**
     * 批量提示行数据，方便子类覆写
     */
    getBatchTipsRowDatas: function (ids, options) {
        var _self = this;
        var $table = $('#entrysIframe').contents().find('#grid');

        var rowDatas = []; //获取选中的表格数据,这种方法只能获取到当前页数据   bug编号：BT1155539
        for (var i = 0, l = ids.length; i < l; i++) {
            rowDatas.push($table.jqGrid('getOriginalRowData', ids[i]));
        }
        // rowDatas = _self.selectedRowData;
        return rowDatas;
    },
});