package com.kingdee.eas.hr.perf.osf;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.bsf.service.app.IHRMsfService;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.util.app.DbUtil;

import java.util.Map;

/**
 * 考核结果管理列表新增显示“整体评价评语”（取最终等级的整体评价评语）
 * description: WholeCommentOSFService <br>
 * date: 2025/6/18 15:32 <br>
 * author: lhbj <br>
 * version: 1.0 <br>
 */
public class WholeCommentOSFService  implements IHRMsfService {
    @Override
    public Object process(Context context, Map<String, Object> map) throws EASBizException, BOSException {
        try {
            String sql =
                    "UPDATE T_EVA_EvaResultSummary SET CFWholeComment = (select to_char(wc.FCOMMENT) FCOMMENT from T_EVA_GradeTaskNodeInst gtni left join T_EVA_WFNodeDef wnf on wnf.fid = gtni.FWFNODEID left join T_PEF_WholeComment wc on wc.FGRADETASKNODEINSTID=gtni.fid where wnf.FISFINALGRADE=1 and wc.FCOMMENT is not null and T_EVA_EvaResultSummary.FEVAOBJID = gtni.FEVAOBJID) WHERE EXISTS (select to_char(wc.FCOMMENT) FCOMMENT from T_EVA_GradeTaskNodeInst gtni left join T_EVA_WFNodeDef wnf on wnf.fid = gtni.FWFNODEID left join T_PEF_WholeComment wc on wc.FGRADETASKNODEINSTID=gtni.fid where wnf.FISFINALGRADE=1 and wc.FCOMMENT is not null and T_EVA_EvaResultSummary.FEVAOBJID = gtni.FEVAOBJID)";
            DbUtil.execute(context,sql);
        }catch (Exception e){
            e.printStackTrace();
            throw e;
        }
        return "ok";
    }
}
